# ]po[ REST Interface
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](http://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](http://www.project-open.com/en/list-installers)

About ]po[ REST Interface:

<p>&shy;The ]po[ &quot;intranet-rest&quot; package implements a Web-Service that exposes most of the ]project-open[ system to external applications that need to read and write ]po[ objects. 

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-authentication-procs.tcl">tcl/intranet-rest-authentication-procs.tcl</a></b></td><td></td><td>REST Web Service Component Library - Authentication </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-create-procs.tcl">tcl/intranet-rest-create-procs.tcl</a></b></td><td></td><td>REST Web Service Component Library </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-data-source-procs.tcl">tcl/intranet-rest-data-source-procs.tcl</a></b></td><td></td><td>REST Web Service Component Library </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-get-procs.tcl">tcl/intranet-rest-get-procs.tcl</a></b></td><td></td><td>REST Web Service Component Library </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-post-procs.tcl">tcl/intranet-rest-post-procs.tcl</a></b></td><td></td><td>REST Web Service Component Library </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-procs.tcl">tcl/intranet-rest-procs.tcl</a></b></td><td></td><td>REST Web Service Component Library </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-sql-parser-procs.tcl">tcl/intranet-rest-sql-parser-procs.tcl</a></b></td><td></td><td>REST Web Service Library Utility functions </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-util-procs.tcl">tcl/intranet-rest-util-procs.tcl</a></b></td><td></td><td>REST Web Service Library Utility functions </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=438563&amp;path=packages/intranet-rest/tcl/intranet-rest-validator-procs.tcl">tcl/intranet-rest-validator-procs.tcl</a></b></td><td></td><td>REST Web Service Validator </td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_quotejson">im_quotejson</a></b></td><td></td><td>Quote a JSON string. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_deref_plpgsql_functions">im_rest_deref_plpgsql_functions</a></b></td><td></td><td>Returns a key-value list of dereference functions per table-column. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_doc_return">im_rest_doc_return</a></b></td><td></td><td>This is a replacement for doc_return that values if the gzip_p URL parameters has been set. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_error">im_rest_error</a></b></td><td></td><td>Returns a suitable REST error message </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_get_content">im_rest_get_content</a></b></td><td></td><td>There&#39;s no [ns_conn content] so this is a hack to get the content of the REST request. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_get_rest_columns">im_rest_get_rest_columns</a></b></td><td></td><td>Reads the &quot;columns&quot; URL variable and returns the list of selected REST columns or an empty list if the variable was not specified. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_hard_coded_deref_plpgsql_functions">im_rest_hard_coded_deref_plpgsql_functions</a></b></td><td></td><td>Returns a key-value list of hard coded attribues per object type. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_normalize_timestamp">im_rest_normalize_timestamp</a></b></td><td></td><td>Reformat JavaScript date/timestamp format to suit PostgreSQL 8.4/9.x </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_columns">im_rest_object_type_columns</a></b></td><td></td><td>Returns a list of all columns for a given object type. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_index_columns">im_rest_object_type_index_columns</a></b></td><td></td><td>Returns a list of all &quot;index columns&quot; for a given object type. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_order_sql">im_rest_object_type_order_sql</a></b></td><td></td><td>returns an &quot;ORDER BY&quot; statement for the *_get_object_type SQL. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_pagination_sql">im_rest_object_type_pagination_sql</a></b></td><td></td><td>Appends pagination information to a SQL statement depending on URL parameters: &quot;LIMIT $limit OFFSET $start&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_select_sql">im_rest_object_type_select_sql</a></b></td><td></td><td>Calculates the SQL statement to extract the value for an object of the given rest_otype. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_subtypes">im_rest_object_type_subtypes</a></b></td><td></td><td>Returns a list of all object types equal or below rest_otype (including rest_otype). </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_object_type_update_sql">im_rest_object_type_update_sql</a></b></td><td></td><td>Updates all the object&#39;s tables with the information from the hash array. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_parse_json_content">im_rest_parse_json_content</a></b></td><td></td><td>Parse the JSON content of a POST request with the values of the object to create or update. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_project_task_tree_action">im_rest_project_task_tree_action</a></b></td><td></td><td>Create, Update or Delete a task coming from TreeStore </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_project_task_tree_assignees">im_rest_project_task_tree_assignees</a></b></td><td></td><td>Update the resource assignees to the task </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_project_task_tree_create">im_rest_project_task_tree_create</a></b></td><td></td><td>Create a new task coming from TreeStore </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_project_task_tree_delete">im_rest_project_task_tree_delete</a></b></td><td></td><td>Delete a task coming from TreeStore </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_project_task_tree_predecessors">im_rest_project_task_tree_predecessors</a></b></td><td></td><td>Update the resource predecessors to the task </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_project_task_tree_update">im_rest_project_task_tree_update</a></b></td><td></td><td>Update a task coming from TreeStore </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=im_rest_valid_sql">im_rest_valid_sql</a></b></td><td></td><td>Returns 1 if &quot;where_clause&quot; is a valid where_clause or 0 otherwise. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_assert">sql_assert</a></b></td><td></td><td>Checks that the string str is of sql type &quot;type&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_between">sql_between</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_compare">sql_compare</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_containing">sql_containing</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_exact">sql_exact</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_from_table_reference">sql_from_table_reference</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_function">sql_function</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_function_count">sql_function_count</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_in">sql_in</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_integer">sql_integer</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_keyword">sql_keyword</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_like">sql_like</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_name">sql_name</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_non_assert">sql_non_assert</a></b></td><td></td><td>Checks that the string str is NOT of sql type &quot;type&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_operator">sql_operator</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_procedure_end">sql_procedure_end</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_search_condition">sql_search_condition</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_search_value">sql_search_value</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_select">sql_select</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_starting">sql_starting</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_test">sql_test</a></b></td><td></td><td>Executes a number of checks </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=438563&amp;proc=sql_value_litteral">sql_value_litteral</a></b></td><td></td><td></td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-rest&amp;url=postgresql/intranet-rest-create.sql&amp;version_id=438563">sql/postgresql/intranet-rest-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-rest&amp;url=postgresql/intranet-rest-drop.sql&amp;version_id=438563">sql/postgresql/intranet-rest-drop.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/auto-login.adp">auto-login.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/auto-login.tcl">auto-login.tcl</a></b></td><td>Home page for REST service, when accessing from the browser.</td></tr><tr valign="top"><td><b>data-source/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/auto-login-token.tcl">auto-login-token.tcl</a></b></td><td>Provide the user with cookies and a login token</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/domain-proxy.adp">domain-proxy.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/domain-proxy.tcl">domain-proxy.tcl</a></b></td><td>Fetches a page from www.project-open.net</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/next-object-id.adp">next-object-id.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/project-task-tree-action.adp">project-task-tree-action.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/project-task-tree-action.tcl">project-task-tree-action.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/project-task-tree.json.adp">project-task-tree.json.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/project-task-tree.json.tcl">project-task-tree.json.tcl</a></b></td><td>Returns a JSON tree structure suitable for batch-loading a project TreeStore</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/data-source/success.adp">success.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/dynfield-widget-values.adp">dynfield-widget-values.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/dynfield-widget-values.tcl">dynfield-widget-values.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/version.adp">version.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=438563&amp;path=packages/intranet-rest/www/version.tcl">version.tcl</a></b></td><td></td></tr></table>

